# Headers
FILE_HEADER = "MThd"
TRACK_HEADER = "MTrk"

# MIDI Channel Events
NOTE_OFF = 0x08
NOTE_ON = 0x09
NOTE_AFTERTOUCH = 0x0A
CONTROLLER = 0x0B
PROGRAM_CHANGE = 0x0C
CHANNEL_AFTERTOUCH = 0x0D
PITCH_BEND = 0x0E
META_EVENT = "\xff"

# MIDI Controller Type
BANK_SELECT = 0x00
MODULATION = 0x01
BREATH_CONTROLLER = 0x02
FOOT_CONTROLLER = 0x04
PORTAMENTO_TIME = 0x05
DATA_ENTRY_MSB = 0x06
MAIN_VOLUME = 0x07
BALANCE = 0x08
PAN = 0x0A
EXPRESSION_CONTROLLER = 0x0B
EFFECT_CONTROL_1 = 0x0C
EFFECT_CONTROL_2 = 0x0D

# Meta Events
SEQUENCE_NUMBER = "\x00"
TEXT_EVENT = "\x01"
COPYRIGHT_NOTICE = "\x02"
TRACK_NAME = "\x03"
INSTRUMENT_NAME = "\x04"
LYRICS = "\x05"
MARKER = "\x06"
CUE_POINT = "\x07"
MIDI_CHANNEL_PREFIX = "\x20"
END_OF_TRACK = "\x2F"
SET_TEMPO = "\x51"
SMPTE_OFFSET = "\x54"
TIME_SIGNATURE = "\x58"
KEY_SIGNATURE = "\x59"

